var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Inject, Injectable } from '@angular/core';
import { Http } from '@angular/http';
import { SERVICE_CONFIG } from '../service.config';
import { HTTP_GET_OPTIONS } from "../utils";
/**
 * Get System information about current backend server.
 * @abstract
 * @class
 */
var SystemInfoService = (function () {
    function SystemInfoService() {
    }
    return SystemInfoService;
}());
export { SystemInfoService };
var SystemInfoDefaultService = (function (_super) {
    __extends(SystemInfoDefaultService, _super);
    function SystemInfoDefaultService(config, http) {
        var _this = _super.call(this) || this;
        _this.config = config;
        _this.http = http;
        return _this;
    }
    SystemInfoDefaultService.prototype.getSystemInfo = function () {
        var url = this.config.systemInfoEndpoint ? this.config.systemInfoEndpoint : '/api/systeminfo';
        return this.http.get(url, HTTP_GET_OPTIONS)
            .toPromise()
            .then(function (systemInfo) { return systemInfo.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    return SystemInfoDefaultService;
}(SystemInfoService));
export { SystemInfoDefaultService };
SystemInfoDefaultService.decorators = [
    { type: Injectable },
];
/** @nocollapse */
SystemInfoDefaultService.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: Inject, args: [SERVICE_CONFIG,] },] },
    { type: Http, },
]; };
//# sourceMappingURL=system-info.service.js.map