var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Injectable } from "@angular/core";
/**
 * Declare interface for error handling
 *
 * @export
 * @abstract
 * @class ErrorHandler
 */
var ErrorHandler = (function () {
    function ErrorHandler() {
    }
    return ErrorHandler;
}());
export { ErrorHandler };
var DefaultErrorHandler = (function (_super) {
    __extends(DefaultErrorHandler, _super);
    function DefaultErrorHandler() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DefaultErrorHandler.prototype.error = function (error) {
        console.error("[Default error handler]: ", error);
    };
    DefaultErrorHandler.prototype.warning = function (warning) {
        console.warn("[Default warning handler]: ", warning);
    };
    DefaultErrorHandler.prototype.info = function (info) {
        console.info("[Default info handler]: ", info);
    };
    DefaultErrorHandler.prototype.log = function (log) {
        console.log("[Default log handler]: ", log);
    };
    return DefaultErrorHandler;
}(ErrorHandler));
export { DefaultErrorHandler };
DefaultErrorHandler.decorators = [
    { type: Injectable },
];
/** @nocollapse */
DefaultErrorHandler.ctorParameters = function () { return []; };
//# sourceMappingURL=error-handler.js.map