var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { TranslateLoader } from '@ngx-translate/core';
import 'rxjs/add/observable/of';
import { Observable } from 'rxjs/Observable';
/**
 * Declare a translation loader with local json object
 *
 * @export
 * @class TranslatorJsonLoader
 * @extends {TranslateLoader}
 */
var TranslatorJsonLoader = (function (_super) {
    __extends(TranslatorJsonLoader, _super);
    function TranslatorJsonLoader(config) {
        var _this = _super.call(this) || this;
        _this.config = config;
        return _this;
    }
    TranslatorJsonLoader.prototype.getTranslation = function (lang) {
        var dict = this.config &&
            this.config.localI18nMessageVariableMap &&
            this.config.localI18nMessageVariableMap[lang] ?
            this.config.localI18nMessageVariableMap[lang] : {};
        return Observable.of(dict);
    };
    return TranslatorJsonLoader;
}(TranslateLoader));
export { TranslatorJsonLoader };
//# sourceMappingURL=local-json.loader.js.map