// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
import { Component, Input } from '@angular/core';
import 'rxjs/add/operator/debounceTime';
import 'rxjs/add/operator/distinctUntilChanged';
import { LABEL_PIEICE_TEMPLATE, LABEL_PIEICE_STYLES } from './label-piece.template';
import { LabelColor } from "../shared/shared.const";
var LabelPieceComponent = (function () {
    function LabelPieceComponent() {
    }
    LabelPieceComponent.prototype.ngOnChanges = function () {
        if (this.label) {
            var color_1 = this.label.color;
            this.labelColor = LabelColor.find(function (data) { return data.color === color_1; });
        }
    };
    LabelPieceComponent.prototype.ngOnInit = function () { };
    return LabelPieceComponent;
}());
export { LabelPieceComponent };
LabelPieceComponent.decorators = [
    { type: Component, args: [{
                selector: 'hbr-label-piece',
                styles: [LABEL_PIEICE_STYLES],
                template: LABEL_PIEICE_TEMPLATE
            },] },
];
/** @nocollapse */
LabelPieceComponent.ctorParameters = function () { return []; };
LabelPieceComponent.propDecorators = {
    'label': [{ type: Input },],
    'labelWidth': [{ type: Input },],
};
//# sourceMappingURL=label-piece.component.js.map