import { OnInit } from '@angular/core';
import { AccessLogService, AccessLog, AccessLogItem } from '../service/index';
import { ErrorHandler } from '../error-handler/index';
import { Comparator, State } from 'clarity-angular';
export declare class RecentLogComponent implements OnInit {
    private logService;
    private errorHandler;
    recentLogs: AccessLogItem[];
    logsCache: AccessLog;
    loading: boolean;
    currentTerm: string;
    withTitle: boolean;
    pageSize: number;
    currentPage: number;
    currentPagePvt: number;
    currentState: State;
    opTimeComparator: Comparator<AccessLogItem>;
    constructor(logService: AccessLogService, errorHandler: ErrorHandler);
    ngOnInit(): void;
    readonly totalCount: number;
    readonly inProgress: boolean;
    doFilter(terms: string): void;
    refresh(): void;
    load(state: State): void;
    isMatched(terms: string, log: AccessLogItem): boolean;
}
